#ifdef _WIN32
	#include <tchar.h>
	#include <conio.h>
#elif (defined __linux__) || (defined _AIX) || (defined __APPLE__)
	typedef char _TCHAR;
	#define _tmain main
#endif

#include <stdio.h>
#include <iostream>
using namespace std;

#include "LinkedList2.h"
//---------------------------------------------------------------------------
TListNode::TListNode()
{
	Data = 0;
	nextPtr = NULL; // dolezite !!!!!!!!!!!!!!!!!!!!!!
}
//---------------------------------------------------------------------------
TListNode::~TListNode()
{
}
//---------------------------------------------------------------------------
TList::TList()
{
	firstPtr = lastPtr = NULL; // dolezite !!!!!!!!!!!!!!
}
//---------------------------------------------------------------------------
TList::~TList()
{
	TListNode *currentPtr = firstPtr, *tempPtr;

	if (!isEmpty()) {
		cout << "\nDeallocating the nodes ...\n";

		while (currentPtr != NULL) {
			tempPtr = currentPtr;
			cout << tempPtr->Data << endl;
			currentPtr = currentPtr->nextPtr;
			delete tempPtr;
		}
		cout << "All the nodes are deallocated.\n";
	}
}
//---------------------------------------------------------------------------
void TList::insertAtFront(const int &data)
{
	TListNode *newPtr = new TListNode();

	newPtr->Data = data;
	if (isEmpty())
		firstPtr = lastPtr = newPtr;
	else {
		newPtr->nextPtr = firstPtr;
		firstPtr = newPtr;
	}
}
//---------------------------------------------------------------------------
void TList::insertBeforeElement(const int &data)
{
	TListNode *newPtr = new TListNode();

	newPtr->Data = data;
	if (isEmpty())
		firstPtr = lastPtr = newPtr;
	else {
		TListNode *currentPtr = firstPtr, *tempPtr = firstPtr;

		if (data < currentPtr->Data) {
			newPtr->nextPtr = firstPtr;
			firstPtr = newPtr;
		}
		else {
			while ((currentPtr != NULL) && (data >= currentPtr->Data)) {
				tempPtr = currentPtr;
				currentPtr = currentPtr->nextPtr;
			}

			newPtr->nextPtr = currentPtr;
			tempPtr->nextPtr = newPtr;
			if (currentPtr == NULL)
				lastPtr = newPtr;
		}
	}
}
//---------------------------------------------------------------------------
void TList::insertAtBack(const int &data)
{
	TListNode *newPtr = new TListNode();

	newPtr->Data = data;
	if (isEmpty())
		firstPtr = lastPtr = newPtr;
	else {
		lastPtr->nextPtr = newPtr;
		lastPtr = newPtr;
	}
}
//---------------------------------------------------------------------------
int TList::removeFromFront(int &data)
{
	if (isEmpty())
		return 0;
	else {
		TListNode *tempPtr = firstPtr;

		if (firstPtr == lastPtr)
			firstPtr = lastPtr = NULL;
		else
			firstPtr = firstPtr->nextPtr;

		data = tempPtr->Data;
		delete tempPtr;
		return 1;
	}
}
//---------------------------------------------------------------------------
int TList::removeFromBack(int &data)
{
	if (isEmpty())
		return 0;
	else {
		TListNode *tempPtr = lastPtr;

		if (firstPtr == lastPtr)
			firstPtr = lastPtr = NULL;
		else {
			TListNode *currentPtr = firstPtr;

			while (currentPtr->nextPtr != lastPtr)
				currentPtr = currentPtr->nextPtr;

			lastPtr = currentPtr;
			currentPtr->nextPtr = NULL;
		}
		data = tempPtr->Data;
		delete tempPtr;
		return 1;
	}
}
//---------------------------------------------------------------------------
void TList::sortElements()
{
	TListNode *firstTempPtr, *secondTempPtr, *thirdTempPtr, *secondPtr;
	bool flaw;

	if (firstPtr != NULL)
		do {
			flaw = false;

			secondPtr = firstPtr->nextPtr;
			if (secondPtr != NULL && firstPtr->Data > secondPtr->Data) {
				firstPtr->nextPtr = secondPtr->nextPtr;
				secondPtr->nextPtr = firstPtr;
				firstPtr = secondPtr;
				flaw = true;
			}

			firstTempPtr = firstPtr;
			secondTempPtr = firstTempPtr->nextPtr;
			thirdTempPtr = secondTempPtr->nextPtr;
			while (thirdTempPtr != NULL) {
				if (secondTempPtr->Data > thirdTempPtr->Data) {
					firstTempPtr->nextPtr = thirdTempPtr;
					secondTempPtr->nextPtr = thirdTempPtr->nextPtr;
					thirdTempPtr->nextPtr = secondTempPtr;
					flaw = true;
				}
				firstTempPtr = firstTempPtr->nextPtr;
				secondTempPtr = firstTempPtr->nextPtr;
				thirdTempPtr = secondTempPtr->nextPtr;
			}
			lastPtr = secondTempPtr;
		} while (flaw);
}
//---------------------------------------------------------------------------
void TList::print() const
{
	TListNode *currentPtr = firstPtr;

	if (isEmpty()) {
		cout << "The list is empty!" << endl << endl;
		return;
	}

	cout << "List = ";
	while (currentPtr != NULL) {
		cout << currentPtr->Data << ' ';
		currentPtr = currentPtr->nextPtr;
	}
	cout << endl << endl;
}
//---------------------------------------------------------------------------
